Subject: Re: someone changed the contents of my HEAD.

From: Dave Jones <[email-masked]>
Date: Tue, 28 Feb 2006 00:58:47 -0500

On Mon, Feb 27, 2006 at 09:22:18PM -0800, Junio C Hamano wrote:
 > > #!/bin/sh
 > > export GIT_AUTHOR_NAME="$1"
 > > export GIT_AUTHOR_EMAIL="$2"
 > > tree=$(git-write-tree) || exit 1
 > > commit=$(git-commit-tree $tree -p HEAD) || exit 1
 > > echo $commit > .git/HEAD
 > 
 > This has been deprecated for a looong time, but perhaps I should
 > have been louder.  "git commit --author" should be fine -- I do
 > not think you do not even need such a wrapper.

I guess I wasn't paying attention :)
It's worked just fine up until a few days ago.
I can change my habits to use the preferred approach though.

 > > For my newly created repos, this isn't a problem, as I can fudge my
 > > commit-as script to write to .git/refs/heads/master instead, but
 > > my concern now is the unpulled changes in the existing repos
 > > I have on master.  Will Linus be able to pull those into his tree
 > > with git 1.2.3, or will I have to recreate those repos with the
 > > new-style .git/HEAD ?
 >
 > A .git/HEAD symlink pointing at refs/heads/master _is_ still
 > (and will be) supported, so either symlink or symref is fine.
 > Bare SHA1 object name in HEAD is not -- git would not know which
 > branch you are on, so "checkin" would not work after that.
 > 
 > Your refs/heads/master might be stale (one rev or more older
 > than what you replaced .git/HEAD with) but still should be a
 > proper ancestor.  After making sure your refs/heads/master has
 > the right commit (you may have it there already if you have been
 > updating them using "git-push"), running "git-symbolic-ref HEAD
 > refs/heads/master" would fix things.

One scary thing fell out of this.  Andrew did a pull on my trees
and found bogons in both of them.  Both agpgart and cpufreq trees
contained partial (1 file) reverts of earlier commits in my last commit
to the head of each repo.  I can't explain how that happened, and
I'm surprised my head-munging would be the reason.

I've just rebuilt those two repos as there was only 3-4 patches
in both, so it wasn't a big deal. Something to watch out for
though if anyone else has been doing something similar to how
I was doing checkins.

		Dave